k = 1; % k steps up or down
n_notes = 20; % number of notes to be used
offset_note = 36; % offset midi note

stencil_pent_major = [2 2 3 2 3]; % -2 -2 -3 -2 -3
stencil_pent_minor = [3 2 2 3 2]; % -3 -2 -2 -3 -2
stencil_diat_major = [2 2 1 2 2 2 1]; % -2 -2 -1 -2 -2 -2 -1
stencil_diat_minor = [2 1 2 2 1 2 2]; % -2 -1 -2 -2 -1 -2 -2

stencil = stencil_diat_major;

array_of_ids = zeros(1,n_notes);
array_of_notes = zeros(1,n_notes);
array_of_notes(1) = offset_note;

% filling the arrays of ids and notes
ids = 1:length(stencil);
index = 1;
for i = 1:n_notes
    array_of_ids(i) = ids(index);
    if i > 1
        array_of_notes(i) = array_of_notes(i-1)+stencil(index);
    end
    index = index+1;
    if index == (length(stencil)+1)
        index = 1;
    end
end

% chord progression (of ids)
chord_progression = [1 1 1 1 4 4 1 1 5 5 5 5 4 4 1]; % one chord per bar

notes_per_bar = [2 3 4 0 3 3 1 0 4 6 4 3 4 4 1];

% automatic composition
index = n_notes/2; % the index near which the composition will start
in_direction = 0; % the initial diretion will be up or down with equivalent probability

% first bar
bar = 1;
in_n_notes = notes_per_bar(bar);
in_id = chord_progression(bar);
if in_n_notes ~= 0
    [out_notes, index, out_direction] = noteskstepsmodelfirstofid(k, in_id, in_n_notes, index, array_of_ids, array_of_notes, in_direction);
else
    out_notes = 0;
    in_n_notes = 1;
    out_direction = 0;
end
nmat = createnmat(out_notes);
nmat = setvalues(nmat,'dur',1/in_n_notes,'sec');
notes_matrix = nmat; % notes matrix for final composition

% remaining bars
for bar = 2:length(chord_progression)
    in_n_notes = notes_per_bar(bar);
    in_id = chord_progression(bar);
    if in_n_notes ~= 0
        if notes_per_bar(bar-1) ~= 0
            if chord_progression(bar) == chord_progression(bar-1)
                [out_notes, index, out_direction] = noteskstepsmodel(k, in_n_notes, index, array_of_notes, out_direction);
            else
                [out_notes, index, out_direction] = noteskstepsmodelfirstofid(k, in_id, in_n_notes, index, array_of_ids, array_of_notes, in_direction);
            end
        else
            [out_notes, index, out_direction] = noteskstepsmodelfirstofid(k, in_id, in_n_notes, index, array_of_ids, array_of_notes, in_direction);
        end
    else
        out_notes = 0;
        in_n_notes = 1;
        out_direction = 0;
    end
    nmat = createnmat(out_notes);
    nmat = setvalues(nmat,'dur',1/in_n_notes,'sec');
    nmat = shift(nmat,'onset',bar-1,'sec');
    notes_matrix = [notes_matrix; nmat];
end

% accompaniment
notes_matrix_acc = [];
index = n_notes/2;
for bar = 1:length(chord_progression)
    in_n_notes = 1;
    in_id = chord_progression(bar);
    [out_notes, index, out_direction] = noteskstepsmodelfirstofid(k, in_id, in_n_notes, index, array_of_ids, array_of_notes, in_direction);
    nmat = createnmat(out_notes);
    nmat = setvalues(nmat,'dur',1/in_n_notes,'sec');
    nmat = shift(nmat,'onset',bar-1,'sec');
    nmat = scale(nmat,'vel',0.5);
    nmat = setvalues(nmat,'chan',1);
    notes_matrix_acc = [notes_matrix_acc; nmat];
end

% play
notes_matrix = settempo(notes_matrix,120);
notes_matrix_acc = settempo(notes_matrix_acc,120);
playsound([notes_matrix; notes_matrix_acc]);
